package com.maintainj.androidaspect;

import java.io.BufferedReader;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;

import com.maintainj.aspect.ExecutionDataAspect;

import com.maintainj.aspect.JoinPointMap;

import android.os.Environment;
import android.util.Log;

import com.maintainj.aspect.ExecutionAspect;

//public aspect MaintainJTracer extends ExecutionAspect{
public aspect MaintainJTracer extends ExecutionDataAspect{
	public pointcut anyExecution(): execution(* com.msi..*(..)) || execution(com.msi..*.new(..));
			
	
	public pointcut beforeMain(): execution(public void com.msi.manning.restaurant.RestaurantFinderApplication.onCreate());
	
	before():beforeMain() 
			&& !execution(* com.maintainj..*(..)) 
			&& !execution(com.maintainj..*.new(..)){
		
		JoinPointMap.setAddJoinPoint(true);
		
		Log.v("MaintainJTracerAspect", "In beforeMain");
		
		//Read the MaintainJTraceController.txt which is updated by the MaintainJ Trace Controller app.
		File path = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS);
		final File myFile = new File(path, "MaintainJTraceController.txt");								
		
		Thread startStopThread = new Thread(new Runnable() {		
			public void run() {
				while(true){
					try {
						//Check the MaintainJTraceController.txt every second
						Thread.sleep(1000);
						FileInputStream fIn = new FileInputStream(myFile);
						BufferedReader myReader = new BufferedReader(new InputStreamReader(fIn));
						String data = myReader.readLine();
						//If the tracing is stopped, write the trace file
						if("stop".equals(data)){						
							JoinPointMap.setAddJoinPoint(false);
							
							if(!JoinPointMap.isEmpty()){
								//Read the trace file name
								String traceFile = myReader.readLine();
								
								File path = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS);
								File myFile = new File(path, traceFile);														
								Log.v("MaintainJTracerAspect", "Writing to trace file:" + myFile.getAbsolutePath());
								JoinPointMap.writeToFile(myFile.getAbsolutePath());
								JoinPointMap.clear();
							}							
						} else if("start".equals(data)){
							JoinPointMap.setAddJoinPoint(true);						
						}
						myReader.close();			
					} catch (Exception e) {
						Log.v("MaintainJTracerAspect", "Exception:" + e.getMessage());
					}
				}
			}
		}); 
		
		//Start the thread
		startStopThread.start();
	}
}
